Program Main
IMPLICIT NONE

    real, ALLOCATABLE :: aij(:,:,:,:,:,:),m(:,:,:,:),m2(:,:,:,:),h(:,:,:,:),hinit(:,:,:,:),htemp(:,:,:,:)
    complex, ALLOCATABLE :: hrf(:,:,:,:)
    real,ALLOCATABLE :: matrx(:,:)
    integer :: n,xmax,ymax,zmax,nx,ny,nz,celltype,ic,rt,mat,matmax,te1,te2,te3
    integer, ALLOCATABLE :: masque(:,:,:),num(:,:,:),degr(:)
    integer :: call,hrfall,scx,scy,scz,nconv
    integer :: rstep,icx,icy,icz,tp,ncv
    real, ALLOCATABLE :: a(:),ms(:)
    real :: cellx,celly,cellz,timestep,endtime,cmax
    real :: xsize,ysize,zsize,cx,cy,cz,cx2,cy2,cz2,maxerror,koeff,rext,rint,height,dx,dy,dz,rcut
    real :: aext,aint,bext,bint,cext,cint
    real :: error,energy,ene,omegastep,beta,r,ttt
    real, allocatable :: tempor(:)
    complex,allocatable :: modes(:,:,:),modesl(:,:,:),w(:),c(:),aij_fft(:,:,:,:,:,:),modes2(:,:,:),modes2l(:,:,:)
    character(255) :: fname
    character(4) :: ident
    real :: hstart,hend,hstep,omega,gyro
    integer :: hdir,coord,hrfini,nn
    real, allocatable :: phases(:,:)
    complex, allocatable :: zout(:,:)
    complex, parameter :: im=(0,1)
    real :: rscale,rcorn
    real, allocatable :: v(:,:),d(:,:)
!
    real, allocatable :: wr(:),wi(:),ztemp(:,:),ztempl(:,:)
!                                                  
    integer :: i,i2,i3,j,ii,lthick,i4,numall,tensalloc
    integer :: x1,x2,x3,y1,y2,y3,z1,z2,z3,x,y,z,scvx,scvy,scvz,vrtype
    character(255) :: liner
    real :: t1,speed,t2,t3,mprf(3),mp(3),mpp(3),phimax,rmax,phi
    integer :: nmodes,ncells
    complex :: tempc
    
    call=0
    hrfall=0
    tensalloc=0
    hrfini=0
    numall=0
    gyro=1
    mp=0
    mprf=0
    beta=0
    scvx=1
    scvy=1
    scvz=1
    vrtype=1
    scx=1
    scy=1
    scz=1
    timestep=-1

    OPEN(UNIT=998,FILE='input.dat',STATUS='OLD',ACTION='READ',FORM='FORMATTED')
    write(*,*) "RKMAG version 2.0"
    write(*,*) "by J.Ketterson and K.Rivkin"
    write(*,*)
665	continue
    read(998,*) liner
    select case (liner)

    case ('LOAD_MAT')
! reads number or materials, and for each of them - A and MS.
	read(998,*) i
	matmax=i
	ALLOCATE(ms(1:i),a(1:i))
	do j=1,i,1
	    read(998,*) a(j),ms(j)
        end do
	write(*,*) "LOAD_MAT ok"

    case ('MASQUE_CREATE')
	read(998,*) cx,cy,cz
	xmax=nint(cx/cellx)-1
	ymax=nint(cy/celly)-1
	zmax=nint(cz/cellz)-1
    	ALLOCATE(masque(0:xmax,0:ymax,0:zmax))
        masque=0
	write(*,*) "MASQUE_CREATE ok"
			
    case ('MASQUE_LOAD')
! load xmax... load the masque itself
    	read(998,*) i
    	read(998,*) fname
    	if (i.eq.2) then
! binary
	    call loadmasqueparam(xmax,ymax,zmax,fname)
	    ALLOCATE(masque(0:xmax,0:ymax,0:zmax))
	    masque=0
	    call loadmasque(masque,xmax,ymax,zmax,fname)
	end if
    	if (i.eq.1) then
! text
    	    call loadmasqueparamt(xmax,ymax,zmax,fname)
	    ALLOCATE(masque(0:xmax,0:ymax,0:zmax))
	    masque=0
	    call loadmasquet(masque,xmax,ymax,zmax,fname)
	end if
	if (i.eq.3) then
! text
    	    call loadmasqueparamt(xmax,ymax,zmax,fname)
	    ALLOCATE(masque(0:xmax,0:ymax,0:zmax))
	    masque=0
	    call loadmasquet2(masque,xmax,ymax,zmax,fname)
	end if
	write(*,*) "MASQUE_LOAD ok"
	
    case ('MASQUE_SAVE')
! save masque
        read(998,*) i
	read(998,*) fname
	if (i.eq.2) then
! binary
	    call savemasque(masque,xmax,ymax,zmax,fname)
	end if
	if (i.eq.1) then
! text
	    call savemasquet(masque,xmax,ymax,zmax,fname)
	end if
	if (i.eq.3) then
! text
	    call savemasquet2(masque,xmax,ymax,zmax,fname)
	end if
	write(*,*) "MASQUE_SAVE ok"
	
    case ('MASQUE_INFO')
	call get_n(masque,xmax,ymax,zmax,n)
	write(*,*) n,xmax+1,ymax+1,zmax+1
	write(*,*) "MASQUE_INFO ok"    
	
    
    case ('ADD_SHAPE')
	read(998,*) i
	if (i.eq.1) then
! a disk 
	    read(998,*) rext,rint,height,cx,cy,cz,mat
	    aext=(rext/(2*cellx))-0.5
	    bext=(rext/(2*celly))-0.5
	    aint=(rint/(2*cellx))-0.5
	    bint=(rint/(2*celly))-0.5
	    height=(height/cellz)-1	    
	    cx=(cx/cellx)+aext
	    cy=(cy/celly)+bext
	    cz=cz/cellz
! cx,cy-center, cz-bottom
! height is the total height
! now cx,cy,cz are cell sizes
	    call calcdisk(masque,xmax,ymax,zmax,aext,bext,aint,bint,height,cx,cy,cz,mat,N)
	end if

	if (i.eq.2) then
! a sphere
	    read(998,*) rext,cx,cy,cz,mat
	    aext=(rext/(2*cellx))-0.5
	    bext=(rext/(2*celly))-0.5
	    cext=(rext/(2*cellz))-0.5
	    
	    aint=0
	    bint=0
	    cint=0
	    cx=cx/cellx+aext
	    cy=cy/celly+bext
	    cz=cz/cellz+cext
	    call calcsphere(masque,xmax,ymax,zmax,aext,bext,cext,aint,bint,cint,cx,cy,cz,mat,N)
	end if

	if (i.eq.3) then
! a slab
	    read(998,*) dx,dy,dz,cx,cy,cz,mat
	    x1=nint(cx/cellx)
	    x2=nint(cy/celly)
	    x3=nint(cz/cellz)
	    y1=nint((dx/cellx)-1)+x1
	    y2=nint((dy/celly)-1)+x2
	    y3=nint((dz/cellz)-1)+x3
!	    write(*,*) x1,x2,x3,y1,y2,y3
	    call calcslab2(masque,xmax,ymax,zmax,x1,y1,x2,y2,x3,y3,mat,N)
	end if

	if (i.eq.4) then
! an ellipse
	    read(998,*) rext,rint,height,cx,cy,cz,mat
! rext,rint here are two external axis - semimajor and semiminor
	    aext=(rext/(2*cellx))-0.5
	    bext=(rint/(2*celly))-0.5
	    aint=0
	    bint=0
	    height=(height/cellz)-1

	    cx=(cx/cellx)+aext
	    cy=(cy/celly)+bext
	    cz=cz/cellz
	    call calcdisk(masque,xmax,ymax,zmax,aext,bext,aint,bint,height,cx,cy,cz,mat,N)
	end if
	

	write(*,*) "ADD_SHAPE ok"
	
    case ('SET_CELL')
        read(998,*) cellx,celly,cellz
	write(*,*) "SET_CELL ok"
	
    case ('STUDY_SHAPE')
        read(998,*) i
! this one allocates the matrix and fills the body
	mat=1
	if (i.eq.1) then
! a disk 
	    read(998,*) rext,rint,height
! now if there is no fft that translates directly into parameters
	    xmax=nint((rext/cellx))-1
	    ymax=nint((rext/celly))-1
	    zmax=nint((height/cellz)-1)
	    aext=(rext/(2*cellx))-0.5
	    bext=(rext/(2*celly))-0.5
	    aint=(rint/(2*cellx))-0.5
	    bint=(rint/(2*celly))-0.5
	    height=(height/cellz)-1
	    cx=real(xmax)/2
	    cy=real(ymax)/2
	    cz=0
	    ALLOCATE(masque(0:xmax,0:ymax,0:zmax))
	    masque=0
	    call calcdisk(masque,xmax,ymax,zmax,aext,bext,aint,bint,height,cx,cy,cz,mat,N)
	end if

	if (i.eq.2) then
! a sphere
	    read(998,*) rext
	    xmax=nint((rext/cellx))-1
	    ymax=nint((rext/celly))-1
	    zmax=nint((rext/cellz))-1
	    aext=(rext/(2*cellx))-0.5
	    bext=(rext/(2*celly))-0.5
	    cext=(rext/(2*cellz))-0.5
	    
	    aint=0
	    bint=0
	    cint=0   
	    
	    cx=real(xmax)/2
	    cy=real(ymax)/2
	    cz=real(zmax)/2
	    ALLOCATE(masque(0:xmax,0:ymax,0:zmax))
	    masque=0
	    call calcsphere(masque,xmax,ymax,zmax,aext,bext,cext,aint,bint,cint,cx,cy,cz,mat,N)
	end if

	if (i.eq.3) then
! a slab-ok
	    read(998,*) dx,dy,dz
	    xmax=nint((dx/cellx))-1
	    ymax=nint((dy/celly))-1
	    zmax=nint((dz/cellz))-1
	    ALLOCATE(masque(0:xmax,0:ymax,0:zmax))
	    masque=0
	    call calcslab2(masque,xmax,ymax,zmax,0,xmax,0,ymax,0,zmax,mat,N)
	end if
	
	if (i.eq.4) then
! an ellipse 
	    read(998,*) rext,rint,height
! now if there is no fft that translates directly into parameters
	    xmax=nint((rext/cellx)-1)
	    ymax=nint((rint/celly)-1)
	    zmax=nint((height/cellz)-1)
	    aext=(rext/(2*cellx))-0.5
	    bext=(rint/(2*celly))-0.5
	    aint=0
	    bint=0
	    height=(height/cellz)-1
	    cx=real(xmax)/2
	    cy=real(ymax)/2
	    cz=0
	    ALLOCATE(masque(0:xmax,0:ymax,0:zmax))
	    masque=0
	    call calcdisk(masque,xmax,ymax,zmax,aext,bext,aint,bint,height,cx,cy,cz,mat,N)
	end if

	write(*,*) "STUDY_SHAPE ok",N    

    case ('TENSOR_MACRO')	
! writes the tensor of the masque in question into macro.txt,macro.dat
	call calcmacro(aij_fft,ms,masque,xmax,ymax,zmax,matmax)
	write(*,*) "TENSOR_MACRO ok"
    
    case ('TENSOR_CREATE')
! reads cell parameters
! same with and w/o fft
! creates for all materials
        tensalloc=1
        ALLOCATE(aij(-xmax:(xmax+1),-ymax:(ymax+1),-zmax:(zmax+1),1:3,1:3,1:matmax))
	aij=0
	read(998,*) nx
	if (nx>0) then
	    read(998,*) ny,nz,rcut
	    do i=1,matmax,1
		call calctensorc(A,Ms,aij,nx,ny,nz,rcut,xmax,ymax,zmax,cellx,celly,cellz,i,matmax)
	    end do
	else
	    do i=1,matmax,1
		call tensornewall(A,Ms,aij,xmax,ymax,zmax,cellx,celly,cellz,i,matmax)
	    end do
	end if
        ALLOCATE(aij_fft(1:(2*xmax+2),1:(2*ymax+2),1:(2*zmax+2),1:3,1:3,1:matmax))
	aij_fft=0
	if (zmax>0) then
	    call aijfft(aij,aij_fft,xmax,ymax,zmax,matmax)    
	else
	    call aijfft2d(aij,aij_fft,xmax,ymax,zmax,matmax)    
	end if
	write(*,*) "TENSOR_CREATE ok"
	
    case ('ADD_ANISOTROPY')
	read(998,*) i,cx,cy,cz,koeff
	call addanisotropy(aij,ms,xmax,ymax,zmax,cx,cy,cz,koeff,i,matmax)
	if (zmax>0) then
	    call aijfft(aij,aij_fft,xmax,ymax,zmax,matmax)    
	else
	    call aijfft2d(aij,aij_fft,xmax,ymax,zmax,matmax)    
	end if
	write(*,*) "ADD_ANISOTROPY ok"

    case ('ADD_ANISOTROPY_FIELD')
	read(998,*) i,cx,cy,cz,koeff
	call addanisotropy_field(aij,ms,xmax,ymax,zmax,cx,cy,cz,koeff,i,matmax)
	if (zmax>0) then
	    call aijfft(aij,aij_fft,xmax,ymax,zmax,matmax)    
	else
	    call aijfft2d(aij,aij_fft,xmax,ymax,zmax,matmax)    
	end if
	write(*,*) "ADD_ANISOTROPY_FIELD ok"
	
    case ('TENSOR_SAVE')
! does not load cell parameters
	read(998,*) i,i2,fname
	if (i2.eq.1) call savetensort(aij,xmax,ymax,zmax,i,matmax,fname)
! text mode
	if (i2.eq.2) call savetensor(aij,xmax,ymax,zmax,i,matmax,fname)
! binary mode
	write(*,*) "TENSOR_SAVE ok"
	
    case ('TENSOR_LOAD')
	if (tensalloc.eq.0) then
	    ALLOCATE(aij(-xmax:(xmax+1),-ymax:(ymax+1),-zmax:(zmax+1),1:3,1:3,1:matmax))
	    ALLOCATE(aij_fft(1:(2*xmax+2),1:(2*ymax+2),1:(2*zmax+2),1:3,1:3,1:matmax))
	    aij=0
	    aij_fft=0
	    tensalloc=1
	end if
	read(998,*) i,i2,fname
	if (i2.eq.1) call loadtensort(aij,xmax,ymax,zmax,i,matmax,fname)
! text mode
	if (i2.eq.2) call loadtensor(aij,xmax,ymax,zmax,i,matmax,fname)
! binary mode
	if (zmax>0) then
	    call aijfft(aij,aij_fft,xmax,ymax,zmax,matmax)    
	else
	    call aijfft2d(aij,aij_fft,xmax,ymax,zmax,matmax)    
	end if
	write(*,*) "TENSOR_LOAD ok"

    case ('ADD_EXT_FIELD')
! all aligned in one direction, or load from the file
	read(998,*) i
	if (i.eq.1) then
	    read(998,*) cx,cy,cz
	    hinit(0:xmax,0:ymax,0:zmax,1)=hinit(0:xmax,0:ymax,0:zmax,1)+cx
    	    hinit(0:xmax,0:ymax,0:zmax,2)=hinit(0:xmax,0:ymax,0:zmax,2)+cy
    	    hinit(0:xmax,0:ymax,0:zmax,3)=hinit(0:xmax,0:ymax,0:zmax,3)+cz
	end if

	if (i.eq.2) then
	    read(998,*) j, fname
	    if(j.eq.1) call loadmt(hinit,masque,xmax,ymax,zmax,fname)
! text
	    if(j.eq.2) call loadm(hinit,masque,xmax,ymax,zmax,fname)
! binary
	end if
	
	write(*,*) "ADD_EXT_FIELD ok"
	
    case ('INIT_M')
    	ALLOCATE(m(0:xmax,0:ymax,0:zmax,1:3))
	ALLOCATE(h(0:xmax,0:ymax,0:zmax,1:3))
	ALLOCATE(hinit(0:xmax,0:ymax,0:zmax,1:3))
	hinit=0
	m=0
	if (hrfall.eq.0) then
	    ALLOCATE(hrf(0:xmax,0:ymax,0:zmax,1:3))
	    hrfall=1
	end if
	hrf=0
	h=0
	read(998,*) i
	if (i.eq.1) then
! initial - vortex
	    cx=real(xmax)/2
	    cy=real(ymax)/2
	    call initvortex(m,ms,xmax,ymax,zmax,masque,cx,cy,matmax)
	end if
	if (i.eq.2) then
! initial - aligned
	    read(998,*) cx,cy,cz
	    call initdir(m,ms,xmax,ymax,zmax,masque,cx,cy,cz,matmax)
	end if
	if (i.eq.3) then
            call initrandom(m,ms,xmax,ymax,zmax,masque,matmax)
	end if
	if (i.eq.4) then
	    call initdir(m,ms,xmax,ymax,zmax,masque,real(1),real(0),real(0),matmax)
	    cz=real(xmax)/4
	    cx=real(xmax)/4
	    cy=real(ymax)/2
!	    call initvortex2(m,ms,xmax,ymax,zmax,masque,cx,cy,cz,1,-1,matmax)
	    cx=real(xmax)/4
	    cy=real(ymax)/2
!	    call initvortex2(m,ms,xmax,ymax,zmax,masque,cx,cy,cz,1,-1,matmax)
	end if
	if (i.eq.9) then
! initial - vortex
	    cx=real(xmax)/2
	    cy=real(ymax)/2
	    call initvortex9(m,ms,xmax,ymax,zmax,masque,cx,cy,matmax)
	end if

    write(*,*) "INIT_M ok"

    case ('CALC_FIELD')
! fft only version
	h=hinit
	call get_n(masque,xmax,ymax,zmax,n)
	if (n>300) then
	    call calcfieldsfft(aij_fft,m,ms,mp,beta,h,masque,xmax,ymax,zmax,matmax)
	else
	    call calcfields(m,ms,mp,beta,masque,aij,h,xmax,ymax,zmax,matmax)
	end if
    	write(*,*) "CALC_FIELD ok"
    
    case ('RELAX')
	read(998,*) i2,maxerror,koeff
	ALLOCATE(m2(0:xmax,0:ymax,0:zmax,1:3))
	m2=0
	call get_n(masque,xmax,ymax,zmax,n)
	if (n>300) then
	    i=2
	else
	    i=1
	end if
! i=1 - direct fields, i=2 - fft
! i2>1 - number of repeated attempts
! koeff is the max
	if (maxerror<0) then
	    maxerror=1D-5
	end if
	energy=1D200
	do j=1,i2,1
	    if (j>1) call initrandom(m,ms,xmax,ymax,zmax,masque,matmax)
	    h=hinit
	    if(koeff>0) then
	        call relax(m,h,ms,mp,beta,aij,masque,xmax,ymax,zmax,matmax,koeff,maxerror,i,aij_fft)
	    else
		call relaxrk4(m,ms,mp,masque,xmax,ymax,zmax,matmax,beta,gyro,timestep,aij,aij_fft,h,i,maxerror)
		h=hinit
		call calcfieldsfft(aij_fft,m,ms,mp,real(0),h,masque,xmax,ymax,zmax,matmax)
	    end if
	    call getenergy(m,masque,h,xmax,ymax,zmax,ene)
!
!	    if (i2>1) then
		write(101,*) j,ene
		write(fname,'(I0,a4)') j,".wrl"
	        call print_red_m(m,xmax,ymax,zmax,masque,real(1),vrtype,scvx,scvy,scvz,fname)
		write(fname,'(I0,a5)') j,"m.dat"
		call savem(m,masque,xmax,ymax,zmax,fname)
		write(fname,'(I0,a5)') j,"h.dat"
		call savem(h,masque,xmax,ymax,zmax,fname)
!	    end if
	    if (ene<energy) then
	    	energy=ene
		m2=m
	    end if
	end do
	m=m2
	if (i2>1) then
	    h=hinit
	    if (n>300) then
		call calcfieldsfft(aij_fft,m,ms,mp,beta,h,masque,xmax,ymax,zmax,matmax)
    	    else
		call calcfields(m,ms,mp,beta,masque,aij,h,xmax,ymax,zmax,matmax)	
	    end if
	end if
! at the end it gives us h and m 
	deallocate(m2)
	write(*,*) "RELAX ok"
    
    case ('SET_TIMESTEP')
	read(998,*) timestep
	if (timestep<0) then
	    omega=0
	    call set_timestep(hinit,hrf,ms,mp,beta,aij,aij_fft,masque,xmax,ymax,zmax,matmax,timestep,omega)
	else
	    timestep=timestep*gyro
	end if
	write(*,*) "timestep=",timestep/gyro
	write(*,*) "SET_TIMESTEP ok"
	
    case ('EXEC')
    	read(998,*) endtime,cmax,fname
! read omega only if hrf have been initialized
	if (hrfini.eq.1) then
	    read(998,*) omega
	else
	    omega=0
	end if
	omega=omega/gyro
! reads entime, whether to do vrml or not, uses pre-defined timestep
! and finally - fname for the output
	call get_n(masque,xmax,ymax,zmax,n)
	if (n>300) then
	    i=2
	else
	    i=1
	end if	
	call fm(m,ms,mp,masque,xmax,ymax,zmax,matmax,beta,gyro,timestep,aij,aij_fft,hinit,hrf,omega,i,endtime,fname,scvx,scvy,scvz,vrtype,cmax)
	write(*,*) "EXEC ok"

    case ('M_SAVE')
	read(998,*) i,fname
	if (i.eq.1) call savemt(m,masque,xmax,ymax,zmax,fname)
! text 		
	if (i.eq.2) call savem(m,masque,xmax,ymax,zmax,fname)
! binary
! vrml
	if (i.eq.4) then
	    call print_red_m(m,xmax,ymax,zmax,masque,real(1),vrtype,scvx,scvy,scvz,fname)
	end if
	write(*,*) "M_SAVE ok"
	
    case ('M_LOAD')
	read(998,*) i,fname
	ALLOCATE(m(0:xmax,0:ymax,0:zmax,1:3))
	ALLOCATE(h(0:xmax,0:ymax,0:zmax,1:3))
	ALLOCATE(hinit(0:xmax,0:ymax,0:zmax,1:3))
	m=0
	h=0
	hinit=0
	if (hrfall.eq.0) then
	    ALLOCATE(hrf(0:xmax,0:ymax,0:zmax,1:3))
	    hrfall=1
	end if
	if (i.eq.1) call loadmt(m,masque,xmax,ymax,zmax,fname)
! text 		
	if (i.eq.2) call loadm(m,masque,xmax,ymax,zmax,fname)
! binary
	write(*,*) "M_LOAD ok"	
	
    case ('H_SAVE')
	read(998,*) i,fname
	if (i.eq.1) call savemt(h,masque,xmax,ymax,zmax,fname)
! text 		
	if (i.eq.2) call savem(h,masque,xmax,ymax,zmax,fname)
! binary
	if (i.eq.3) then
	    call print_red_m(h,xmax,ymax,zmax,masque,real(1),vrtype,scvx,scvy,scvz,fname)
	    DEALLOCATE(tempor)
	end if
! vrml
	write(*,*) "H_SAVE ok"	

    case ('H_AVERAGE')
	read(998,*) cx,cy,cz,cx2,cy2,cz2
	mpp=0
	x1=cx/cellx
	x2=cy/celly
	x3=cz/cellz
	y1=(cx2/cellx)-1
	y2=(cy2/celly)-1
	y3=(cz2/cellz)-1
	i=0
	do x=x1,y1
	do y=x2,y2
	do z=x3,y3
	    if (((x<=xmax).and.(y<=ymax).and.(z<=zmax)).and.(masque(x,y,z).ne.0)) then
		i=i+1
		mpp(1:3)=mpp(1:3)+h(x,y,z,1:3)
	    end if
	end do
	end do
	end do
	mpp=mpp/i
	write(*,*) mpp    
	write(*,*) "H_AVERAGE ok"
		
    case ('H_LOAD')
	read(998,*) i,fname
	if (i.eq.1) call loadmt(h,masque,xmax,ymax,zmax,fname)
! text 		
	if (i.eq.2) call loadm(h,masque,xmax,ymax,zmax,fname)
! binary
	write(*,*) "H_LOAD ok"	
	
    case ('SET_SCALE')
	numall=1
	ALLOCATE(num(0:xmax,0:ymax,0:zmax))
	num=0
	read(998,*) scx,scy,scz
	call number(masque,num,xmax,ymax,zmax,ncells,scx,scy,scz)
	ALLOCATE(degr(1:ncells))
	degr=0
	call deg(degr,masque,num,xmax,ymax,zmax,ncells,scx,scy,scz)
	write(*,*) "SET_SCALE ok",ncells

    case ('SET_SCALE_R')
	numall=1
	ALLOCATE(num(0:xmax,0:ymax,0:zmax))
	num=0
	read(998,*) rscale,scx,scy
	scz=zmax+1
	call number_r(masque,num,xmax,ymax,zmax,ncells,rscale,cellx,celly,scx,scy,scz)
	ALLOCATE(degr(1:ncells))
	degr=0
	call deg(degr,masque,num,xmax,ymax,zmax,ncells,scx,scy,scz)
	write(*,*) "SET_SCALE ok",ncells

    case ('SET_SCALE_R2')
	numall=1
	ALLOCATE(num(0:xmax,0:ymax,0:zmax))
	num=0
	read(998,*) koeff,rscale,rcorn,scx,scy
	scz=zmax+1
	call number_r2(masque,m,num,xmax,ymax,zmax,ncells,koeff,rscale,rcorn,cellx,celly,scx,scy,scz)
	ALLOCATE(degr(1:ncells))
	degr=0
	call deg(degr,masque,num,xmax,ymax,zmax,ncells,scx,scy,scz)
	write(*,*) "SET_SCALE ok",ncells

    case ('SOLVE_MATRIX')
    	read(998,*) nmodes
	if (numall.eq.0) then
	    numall=1
	    ALLOCATE(num(0:xmax,0:ymax,0:zmax))
	    num=0
	    call number(masque,num,xmax,ymax,zmax,ncells,scx,scy,scz)
	    ALLOCATE(degr(1:ncells))
	    degr=0
	    call deg(degr,masque,num,xmax,ymax,zmax,ncells,scx,scy,scz)
	end if
	if (nmodes<0) nmodes=ncells
!
!	ALLOCATE(wr(1:(2*nmodes)),wi(1:(2*nmodes)),ztemp(1:(2*nmodes),1:(2*nmodes)),ztempl(1:(2*nmodes),1:(2*nmodes)))
!	wr=0
!	wi=0
!	ztemp=0
!	ztempl=0

	ALLOCATE(w(1:nmodes),modes(1:ncells,1:2,1:nmodes),modesl(1:ncells,1:2,1:nmodes))
	w=0
	modes=0
	modesl=0
	ALLOCATE(phases(1:ncells,1:4),zout(1:ncells,1:2))
	phases=0
	zout=0
	
	call calcmatrix(m,aij,h,mp,beta,masque,num,xmax,ymax,zmax,ms,matmax,ncells,nmodes,degr,w,modes,modesl)
!!!!!
!!!	modesl=modes
!	call sort(ztemp,modes,wr,wi,w,ncells,nmodes)
!	call sort(ztempl,modesl,wr,wi,w,ncells,nmodes)
!	deallocate(wr,wi,ztemp,ztempl)
	call savemodes(modes,w,ncells,nmodes,num,masque,xmax,ymax,zmax,"eig.dat")
	call savemodes(modesl,w,ncells,nmodes,num,masque,xmax,ymax,zmax,"eigl.dat")
	write(*,*) "SOLVE_MATRIX ok"

    case ('SOLVE_MATRIX_AR')
	read(998,*) i
    	read(998,*) nmodes,ncv
	if (i.eq.2) read(998,*) rcut
	nmodes=nmodes*2
	ncv=ncv*2
	if (numall.eq.0) then
	    numall=1
	    ALLOCATE(num(0:xmax,0:ymax,0:zmax))
	    num=0
	    call number(masque,num,xmax,ymax,zmax,ncells,scx,scy,scz)
	    ALLOCATE(degr(1:ncells))
	    degr=0
	    call deg(degr,masque,num,xmax,ymax,zmax,ncells,scx,scy,scz)
	end if
	if (nmodes<0) nmodes=ncells

	allocate(d(ncv,3),v(2*ncells,ncv))
	if (i<2) then	
    	    call calcmatrix_ns(m,aij,h,mp,beta,masque,num,xmax,ymax,zmax,ms,matmax,ncells,nmodes,ncv,degr,v,d,nconv)
	else
	    call calcmatrix_s(m,aij,h,mp,beta,masque,num,xmax,ymax,zmax,ms,matmax,ncells,nmodes,ncv,cellx,celly,cellz,rcut,v,d,nconv)
	end if
	    
	nmodes=0
	do i=1,nconv
	    if(d(i,2)>0) then
		nmodes=nmodes+1
	    end if
	end do		
	ALLOCATE(w(1:nmodes),modes(1:ncells,1:2,1:nmodes),modesl(1:ncells,1:2,1:nmodes))
	w=0
	modes=0
	ALLOCATE(phases(1:ncells,1:4),zout(1:ncells,1:2))
	phases=0
	zout=0
	call sort_ar(v,d,modes,w,ncells,ncv,nconv,nmodes)
	modesl=modes
	call savemodes(modes,w,ncells,nmodes,num,masque,xmax,ymax,zmax,"eig.dat")
	call savemodes(modesl,w,ncells,nmodes,num,masque,xmax,ymax,zmax,"eigl.dat")
	write(*,*) "SOLVE_MATRIX_AR ok"

    case ('EIGEN_SAVE_TEXT')
	read(998,*) i,fname
	if (i.eq.1) then
	    call savemodest(modes,w,masque,xmax,ymax,zmax,num,ncells,nmodes,fname)
	else
	    call savemodest(modesl,w,masque,xmax,ymax,zmax,num,ncells,nmodes,fname)
	end if
	write(*,*) "EIGEN_SAVE ok"	

    case ('OMEGA_PRINT')
	read(998,*) fname
	OPEN(UNIT=999,FILE=fname,STATUS='REPLACE',FORM='FORMATTED')
	do i=1,nmodes,1
	   write(999,'(I6,2F25.5)') i,real(w(i))*gyro,imag(w(i))*gyro
	end do
	CLOSE(999)
	write(*,*) "OMEGA_PRINT ok"
	
    case ('EIGEN_LOAD')
	if (numall.eq.0) then
            numall=1
	    ALLOCATE(num(0:xmax,0:ymax,0:zmax))
	    num=0
	    call read_number(num,xmax,ymax,zmax,ncells,nmodes,"eig.dat")
	    ALLOCATE(degr(1:ncells))
	    degr=0
	    call deg(degr,masque,num,xmax,ymax,zmax,ncells,scx,scy,scz)
	else
	    nmodes=ncells
	end if
	
	ALLOCATE(phases(1:ncells,1:4),zout(1:ncells,1:2))
	phases=0
	zout=0
	ALLOCATE(w(1:nmodes),modes(1:ncells,1:2,1:nmodes),modesl(1:ncells,1:2,1:nmodes))
	w=0
	modes=0
	modesl=0
	call loadmodes(modes,w,ncells,nmodes,"eig.dat")
	call loadmodes(modesl,w,ncells,nmodes,"eigl.dat")
	write(*,*) "EIGEN_LOAD ok"	

    case ('SET_CURRENT')
! set currents for all time-dependent functions, relaxation functions and     
	read(998,*) t1
	read(998,*) mp(1:3)
	t2=sqrt(mp(1)*mp(1)+mp(2)*mp(2)+mp(3)*mp(3))
	mp=mp/t2
	mp=mp*t1
	write(*,*) "SET_CURRENT ok"    
	
    case ('SET_BETA')
    	read(998,*) beta
	write(*,*) "SET_BETA ok"    

    case ('SET_VRML')
    	read(998,*) scvx,scvy,scvz,vrtype
	write(*,*) "SET_SCALE_VRML ok"    
    	
    case ('SET_HRF')
	hrfini=1
	read(998,*) i
	! 1-uniform 2- linear, 3 - from file 4 - from currents
	!check if hrf allocated
	if (hrfall.eq.0) then
	    ALLOCATE(hrf(0:xmax,0:ymax,0:zmax,1:3))
	    hrfall=1
	end if
	hrf=0
	if (i<3) read(998,*) cx,cx2,cy,cy2,cz,cz2
	if (i.eq.1) then
	    hrf(0:xmax,0:ymax,0:zmax,1)=cx+im*cx2
	    hrf(0:xmax,0:ymax,0:zmax,2)=cy+im*cy2
	    hrf(0:xmax,0:ymax,0:zmax,3)=cz+im*cz2
	end if
	if (i.eq.2) then
! linear
	    read(998,*) i2
	    if (i2.eq.1) then
		do j=0,xmax,1
		    hrf(j,0:ymax,0:zmax,1)=(cx+im*cx2)*(1-j*2/real(xmax))
		    hrf(j,0:ymax,0:zmax,2)=(cy+im*cy2)*(1-j*2/real(xmax))
		    hrf(j,0:ymax,0:zmax,3)=(cz+im*cz2)*(1-j*2/real(xmax))
		end do
	    end if
	    if (i2.eq.2) then
	    do j=0,ymax,1
	    	hrf(0:xmax,j,0:zmax,1)=(cx+im*cx2)*(1-j*2/real(ymax))
		hrf(0:xmax,j,0:zmax,2)=(cy+im*cy2)*(1-j*2/real(ymax))
		hrf(0:xmax,j,0:zmax,3)=(cz+im*cz2)*(1-j*2/real(ymax))
	    end do
	    end if
	    if (i2.eq.3) then
	    do j=0,zmax,1
	    	hrf(0:xmax,0:ymax,j,1)=(cx+im*cx2)*(1-j*2/real(zmax))
	    	hrf(0:xmax,0:ymax,j,2)=(cy+im*cy2)*(1-j*2/real(zmax))
	    	hrf(0:xmax,0:ymax,j,3)=(cz+im*cz2)*(1-j*2/real(zmax))
	    end do
	    end if
	end if
	if (i.eq.3) then
	    read(998,*) i2,fname
	    if (i2.eq.1) call loadhrft(hrf,masque,xmax,ymax,zmax,fname)
! text only
!	    if (i2.eq.2) call loadhrf(hrf,masque,xmax,ymax,zmax,fname)
! binary
	end if
	if (i.eq.4) then
	    read(998,*) t1
	    read(998,*) mprf(1:3)
	    hrf=0	
! in the first material only
	    t2=sqrt(mprf(1)*mprf(1)+mprf(2)*mprf(2)+mprf(3)*mprf(3))
	    mprf=mprf/t2
	    mprf=mprf*t1
! hrf=-t1(mxms)	
	    call vectormult2(hrf,m,mprf,ms,matmax,masque,xmax,ymax,zmax)
	    hrf=-hrf
	end if
	write(*,*) "SET_HRF ok"	

    case ('CALC_C')
! check if c is allocated
	if (call.eq.0) then
		ALLOCATE(c(1:nmodes))
		call=1
	end if
	c=0
	call calc_c(c,m,hrf,modes,modesl,masque,num,degr,xmax,ymax,zmax,ncells,nmodes)
	write(*,*) "CALC_C ok"	

    case ('SET_GYRO')
	read(998,*) gyro
	write(*,*) "SET_GYRO ok"
	
    case ('PRINT_C')
    	read(998,*) fname
	call print_c(c,w,nmodes,gyro,fname)
	write(*,*) "PRINT_C ok"	

    case ('PRINT_ABS')
	read(998,*) fname
	read(998,*) omegastep
	call print_abs(c,w,omegastep,nmodes,gyro,fname)
	write(*,*) "PRINT_ABS ok"	
	
    case ('PRINT_PHASES')
	read(998,*) i,i2
	call print_phases(modes,w,ncells,nmodes,i,i2,masque,xmax,ymax,zmax,num,0,scx,scy,scz)
	write(*,*) "PRINT_PHASES ok"

! now the procedures to draw the modes

    case ('DRAW_MODES')
	read(998,*) i,i2
	do j=i,i2,1
	    zout(1:ncells,1:2)=modes(1:ncells,1:2,j)
	    call drawmode(zout,ncells,masque,xmax,ymax,zmax,num,20,0,j,2)
	end do	
	write(*,*) "DRAW_MODES ok"

    case ('DRAW_MODES_E')
	read(998,*) t1
	phi=0
	t2=0
	do j=1,nmodes
	    if (imag(c(j))>t2) t2=imag(c(j))
	end do
	do j=1,nmodes
	    if (imag(c(j))>=t2*t1) then
		zout(1:ncells,1:2)=modes(1:ncells,1:2,j)
		call drawmode(zout,ncells,masque,xmax,ymax,zmax,num,20,0,j,2)
		do coord=1,3
		    call drawmode_proj(zout,ncells,m,masque,ms,matmax,xmax,ymax,zmax,num,coord,j,phi,coord)
		end do
	    end if
	end do	
	write(*,*) "DRAW_MODES_E ok"

    case ('DRAW_MODES_P')
	read(998,*) coord,phi
	read(998,*) i,i2
	do j=i,i2,1
	    zout(1:ncells,1:2)=modes(1:ncells,1:2,j)
	    call drawmode_proj(zout,ncells,m,masque,ms,matmax,xmax,ymax,zmax,num,coord,j,phi,coord)
	end do	
	write(*,*) "DRAW_MODES_P ok"
	
    case ('PRINT_SLICES')
	read(998,*) i,i2,i3,icx,icy,icz
	do j=i,i2,1
	    zout(1:ncells,1:2)=modes(1:ncells,1:2,j)
	    call norm_to_draw(zout,real(1),ncells,phases,real(0))
	    call find_phase(zout,ncells,phases,rmax,phimax)
	    
	    call print_slice(phases,ncells,j,masque,xmax,ymax,zmax,num,i3,icx,icy,icz,scx,scy,scz,0)
	end do	
	write(*,*) "PRINT_SLICES ok"
    
    case ('PRINT_ANGLE')
	read(998,*) i,i2,i3,cx,cy,cz,rcut
	do j=i,i2,1
	    zout(1:ncells,1:2)=modes(1:ncells,1:2,j)
	    call norm_to_draw(zout,real(1),ncells,phases,real(0))
	    call find_phase(zout,ncells,phases,rmax,phimax)
	    call print_angle(phases,ncells,j,masque,xmax,ymax,zmax,num,i3,cx,cy,cz,scx,scy,scz,rcut,0)
	end do    
	write(*,*) "PRINT_ANGLE ok"

    case ('VEC3')
    	read(998,*) nn,endtime,cmax,fname
	if (hrfini.eq.1) then
	    read(998,*) omega
	else
	    omega=0
	end if
	omega=omega/gyro
	!!!!
!	omega=600
	!!!!
!	write(*,*) omega
	tempc=0
	do i=1,ncells
	do j=1,2
	    tempc=tempc+modes(i,j,1)*conjg(modes(i,j,8))
	end do
	end do
	write(*,*) tempc

    	ALLOCATE(modes2(1:ncells,1:3,nn),modes2l(1:ncells,1:3,nn))
	call t23(m,modes,modes2,masque,num,degr,xmax,ymax,zmax,ncells,nmodes,nn)
	call t23(m,modesl,modes2l,masque,num,degr,xmax,ymax,zmax,ncells,nmodes,nn)
	deallocate(modes,modesl)
	call norm3(modes2,modes2l,ncells,nn)
!
!	call ort(modes2,modes2l,ncells,nn)
!	call ort(modes2,modes2,ncells,nn)
!
	! now we run fm with modes
	call get_n(masque,xmax,ymax,zmax,n)
	if (n>300) then
	    i=2
	else
	    i=1
	end if
	modes2l=conjg(modes2l)
	call fm3(m,ms,mp,masque,xmax,ymax,zmax,matmax,beta,gyro,timestep,aij,aij_fft,hinit,hrf,omega,i,endtime,fname,modes2l,ncells,nn,num,cmax)
	
	write(*,*) "VEC3 ok"
	
    case ('END')
	goto 667
		
	
end select
	goto 665
667 continue
	CLOSE(998)
	
END Program Main