!DEC$ DEFINE rflag=8
subroutine calctensorc(A,Ms,aij,nx,ny,nz,rcut,xmax,ymax,zmax,xstep,ystep,zstep,mat,matmax)
	integer :: xmax,ymax,zmax,nx,ny,nz,matmax,mat
	real :: A(1:matmax),Ms(1:matmax),rcut,xstep,ystep,zstep
	real, INTENT (INOUT) :: aij(-xmax:(xmax+1),-ymax:(ymax+1),-zmax:(zmax+1),1:3,1:3,1:matmax)
	integer :: x,y,z,i,j,k,i2,j2,k2
	real :: t1,t2,t3,t4,temp1,temp2,temp3,temp12,temp22,temp32,r
	real :: Jx,Jy,Jz,v

	Jx=2*A(mat)/(Ms(mat)*Ms(mat)*xstep*xstep)
	Jy=2*A(mat)/(Ms(mat)*Ms(mat)*ystep*ystep)
	Jz=2*A(mat)/(Ms(mat)*Ms(mat)*zstep*zstep)
	v=(xstep/nx)*(ystep/ny)*(zstep/nz)
do x=-xmax,xmax+1,1
	do y=-ymax,ymax+1,1
	 do z=-zmax,zmax+1,1

	r=sqrt(real(x*xstep*x*xstep+y*y*ystep*ystep+z*zstep*zstep*z))

	if (r<rcut) then
	do i2=1,nx,1
		do j2=1,ny,1
			do k2=1,nz,1
	do i=1,nx,1
		do j=1,ny,1
			do k=1,nz,1

				t1=xstep/nx
				t2=ystep/ny
				t3=zstep/nz

				temp1=(-xstep/2)+(t1/2)+t1*(i-1)
				temp2=(-ystep/2)+(t2/2)+t2*(j-1)
				temp3=(-zstep/2)+(t3/2)+t3*(k-1)

				temp12=x*xstep-(xstep/2)+(t1/2)+t1*(i2-1)
				temp22=y*ystep-(ystep/2)+(t2/2)+t2*(j2-1)
				temp32=z*zstep-(zstep/2)+(t3/2)+t3*(k2-1)

				temp1=temp12-temp1
				temp2=temp22-temp2
				temp3=temp32-temp3

				r=sqrt(temp1*temp1+temp2*temp2+temp3*temp3)

				if (r>(1D-24)) then
					t4=1/(r*r*r)
					t3=t4/(r*r)

					aij(x,y,z,1,1,mat)=aij(x,y,z,1,1,mat)+3*temp1*temp1*t3-t4
					aij(x,y,z,1,2,mat)=aij(x,y,z,1,2,mat)+3*temp1*temp2*t3
					aij(x,y,z,1,3,mat)=aij(x,y,z,1,3,mat)+3*temp1*temp3*t3

					aij(x,y,z,2,2,mat)=aij(x,y,z,2,2,mat)+3*temp2*temp2*t3-t4
					aij(x,y,z,2,3,mat)=aij(x,y,z,2,3,mat)+3*temp2*temp3*t3
					aij(x,y,z,3,3,mat)=aij(x,y,z,3,3,mat)+3*temp3*temp3*t3-t4
				end if	
						
			end do
		end do
	end do
	end do
	end do
	end do

	aij(x,y,z,2,1,mat)=aij(x,y,z,1,2,mat)
	aij(x,y,z,3,1,mat)=aij(x,y,z,1,3,mat)
	aij(x,y,z,3,2,mat)=aij(x,y,z,2,3,mat)
	t1=nx*ny*nz
	aij(x,y,z,1:3,1:3,mat)=v*aij(x,y,z,1:3,1:3,mat)/t1

    else
	do i=1,nx,1
		do j=1,ny,1
			do k=1,nz,1

				t1=xstep/nx
				t2=ystep/ny
				t3=zstep/nz

				temp1=-(xstep/2)+(t1/2)+t1*(i-1)
				temp2=-(ystep/2)+(t2/2)+t2*(j-1)
				temp3=-(zstep/2)+(t3/2)+t3*(k-1)

				temp1=x*xstep-temp1
				temp2=y*ystep-temp2
				temp3=z*zstep-temp3

				r=sqrt(temp1*temp1+temp2*temp2+temp3*temp3)
			if (r>(1D-24)) then
				t4=1/(r*r*r)
				t3=t4/(r*r)
		
				aij(x,y,z,1,1,mat)=aij(x,y,z,1,1,mat)+3*temp1*temp1*t3-t4
				aij(x,y,z,1,2,mat)=aij(x,y,z,1,2,mat)+3*temp1*temp2*t3
				aij(x,y,z,1,3,mat)=aij(x,y,z,1,3,mat)+3*temp1*temp3*t3

				aij(x,y,z,2,2,mat)=aij(x,y,z,2,2,mat)+3*temp2*temp2*t3-t4
				aij(x,y,z,2,3,mat)=aij(x,y,z,2,3,mat)+3*temp2*temp3*t3
				aij(x,y,z,3,3,mat)=aij(x,y,z,3,3,mat)+3*temp3*temp3*t3-t4
			end if
			end do
		end do
	end do
		aij(x,y,z,2,1,mat)=aij(x,y,z,1,2,mat)
		aij(x,y,z,3,1,mat)=aij(x,y,z,1,3,mat)
		aij(x,y,z,3,2,mat)=aij(x,y,z,2,3,mat)
		aij(x,y,z,1:3,1:3,mat)=v*aij(x,y,z,1:3,1:3,mat)
end if

!	r=sqrt(real(x*x+y*y+z*z))
	if ((abs(x).eq.1).and.(y.eq.0).and.(z.eq.0)) then
		aij(x,y,z,1,1,mat)=aij(x,y,z,1,1,mat)+Jx
		aij(x,y,z,2,2,mat)=aij(x,y,z,2,2,mat)+Jx
		aij(x,y,z,3,3,mat)=aij(x,y,z,3,3,mat)+Jx
	end if
	if ((x.eq.0).and.(abs(y).eq.1).and.(z.eq.0)) then
		aij(x,y,z,1,1,mat)=aij(x,y,z,1,1,mat)+Jy
		aij(x,y,z,2,2,mat)=aij(x,y,z,2,2,mat)+Jy
		aij(x,y,z,3,3,mat)=aij(x,y,z,3,3,mat)+Jy
	end if

	if ((x.eq.0).and.(y.eq.0).and.(abs(z).eq.1)) then
		aij(x,y,z,1,1,mat)=aij(x,y,z,1,1,mat)+Jz
		aij(x,y,z,2,2,mat)=aij(x,y,z,2,2,mat)+Jz
		aij(x,y,z,3,3,mat)=aij(x,y,z,3,3,mat)+Jz
	end if

!	if ((r>0.0001).and.(r<1.05)) then
!		aij(x,y,z,1,1,mat)=aij(x,y,z,1,1,mat)+Jx
!		aij(x,y,z,2,2,mat)=aij(x,y,z,2,2,mat)+Jy
!		aij(x,y,z,3,3,mat)=aij(x,y,z,3,3,mat)+Jz
!	end if

end do
end do
end do

!!!
!    aij(0,0,0,:,:,mat)=0
    

end subroutine calctensorc

subroutine aijfft(aij,aij_fft,xmax,ymax,zmax,matmax)
	use MKL_DFTI
	
	type(DFTI_DESCRIPTOR), POINTER :: Mydescr
	integer :: L(1:3),status
	integer :: i,j,k,xmax,ymax,zmax,x,y,z,xx,yy,zz,matmax
	real, intent(in) :: aij(-xmax:(xmax+1),-ymax:(ymax+1),-zmax:(zmax+1),1:3,1:3,1:matmax)
	complex, intent(out) :: aij_fft(1:(2*xmax+2),1:(2*ymax+2),1:(2*zmax+2),1:3,1:3,1:matmax)
	complex :: aijtemp(1:(2*xmax+2),1:(2*ymax+2),1:(2*zmax+2))
	complex :: X_IN((2*xmax+2)*(2*ymax+2)*(2*zmax+2))
	integer :: strides(4)
	
	aij_fft=0
	L(1)=2*xmax+2
	L(2)=2*ymax+2
	L(3)=2*zmax+2
	
	strides(1)=0
	strides(2)=1
	strides(3)=(2*xmax+2)
	strides(4)=(2*xmax+2)*(2*ymax+2)

	do k=1,matmax,1
	do i=1,3,1
	do j=1,3,1
	
		do x=1,2*xmax+2,1
		do y=1,2*ymax+2,1
		do z=1,2*zmax+2,1
		    if (x>(xmax+2)) then
			xx=x-2*xmax-3
		    else
			xx=x-1
		    end if
		    if (y>(ymax+2)) then
			yy=y-2*ymax-3
		    else
			yy=y-1
		    end if
		    if (z>(zmax+2)) then
			zz=z-2*zmax-3
		    else
			zz=z-1
		    end if
		    aijtemp(x,y,z)=aij(xx,yy,zz,i,j,k)
		end do
		end do
		end do

		do x=1,(2*xmax+2),1
		do y=1,(2*ymax+2),1
		do z=1,(2*zmax+2),1
    		    X_IN(x+(2*xmax+2)*(y-1)+(2*xmax+2)*(2*ymax+2)*(z-1))=aijtemp(x,y,z)
		end do
		end do
		end do

!DEC$ IF (rflag.eq.4)
		status=DftiCreateDescriptor(Mydescr,DFTI_SINGLE,DFTI_COMPLEX,3,L)
!DEC$ ELSE
		status=DftiCreateDescriptor(Mydescr,DFTI_DOUBLE,DFTI_COMPLEX,3,L)
!DEC$ ENDIF
		status=DftiSetValue(Mydescr,DFTI_INPUT_STRIDES,strides)
		status=DftiCommitDescriptor(Mydescr)
		status=DftiComputeForward(Mydescr,X_IN)
		status=DftiFreeDescriptor(Mydescr)

		do x=1,(2*xmax+2),1
		do y=1,(2*ymax+2),1
		do z=1,(2*zmax+2),1
    		    aijtemp(x,y,z)=X_IN(x+(2*xmax+2)*(y-1)+(2*xmax+2)*(2*ymax+2)*(z-1))
		end do
		end do
		end do
		aij_fft(:,:,:,i,j,k)=aijtemp(:,:,:)
	end do
	end do
	end do
	
end subroutine aijfft

subroutine aijfft2d(aij,aij_fft,xmax,ymax,zmax,matmax)
	use MKL_DFTI
	
	type(DFTI_DESCRIPTOR), POINTER :: Mydescr
	integer :: L(1:2),status
	integer :: i,j,k,xmax,ymax,zmax,x,y,z,xx,yy,zz,matmax
	real, intent(in) :: aij(-xmax:(xmax+1),-ymax:(ymax+1),-zmax:(zmax+1),1:3,1:3,1:matmax)
	complex, intent(out) :: aij_fft(1:(2*xmax+2),1:(2*ymax+2),1:(2*zmax+2),1:3,1:3,1:matmax)
	complex :: aijtemp(1:(2*xmax+2),1:(2*ymax+2))
	complex :: X_IN((2*xmax+2)*(2*ymax+2))
	integer :: strides(3)
	
	aij_fft=0
	L(1)=2*xmax+2
	L(2)=2*ymax+2
	
	strides(1)=0
	strides(2)=1
	strides(3)=(2*xmax+2)

	do k=1,matmax,1
	do i=1,3,1
	do j=1,3,1
		do x=1,2*xmax+2,1
		do y=1,2*ymax+2,1
		    if (x>(xmax+2)) then
			xx=x-2*xmax-3
		    else
			xx=x-1
		    end if
		    if (y>(ymax+2)) then
			yy=y-2*ymax-3
		    else
			yy=y-1
		    end if
		    aijtemp(x,y)=aij(xx,yy,0,i,j,k)
		end do
		end do

		do x=1,(2*xmax+2),1
		do y=1,(2*ymax+2),1
    		    X_IN(x+(2*xmax+2)*(y-1))=aijtemp(x,y)
		end do
		end do

!DEC$ IF (rflag.eq.4)
		status=DftiCreateDescriptor(Mydescr,DFTI_SINGLE,DFTI_COMPLEX,2,L)
!DEC$ ELSE
		status=DftiCreateDescriptor(Mydescr,DFTI_DOUBLE,DFTI_COMPLEX,2,L)
!DEC$ ENDIF
		status=DftiSetValue(Mydescr,DFTI_INPUT_STRIDES,strides)
		status=DftiCommitDescriptor(Mydescr)
		status=DftiComputeForward(Mydescr,X_IN)
		status=DftiFreeDescriptor(Mydescr)

		do x=1,(2*xmax+2),1
		do y=1,(2*ymax+2),1
    		    aijtemp(x,y)=X_IN(x+(2*xmax+2)*(y-1))
		end do
		end do
		aij_fft(:,:,1,i,j,k)=aijtemp(:,:)
	end do
	end do
	end do
	
end subroutine aijfft2d


subroutine savetensort(aij,xmax,ymax,zmax,mat,matmax,fname)
integer :: xmax,ymax,zmax,i,j,x,y,z,mat,matmax
real, INTENT (IN) :: aij(-xmax:(xmax+1),-ymax:(ymax+1),-zmax:(zmax+1),1:3,1:3,1:matmax)
character(255) :: fname

OPEN(UNIT=999,FILE=fname,STATUS='REPLACE',ACTION='WRITE',FORM='FORMATTED')

write(999,'(I9)') (2*xmax+2)*(2*ymax+2)*(2*zmax+2)
do x=-xmax,xmax+1,1
	do y=-ymax,ymax+1,1
	 do z=-zmax,zmax+1,1
		write(999,'(3I6)') x,y,z
		do i=1,3,1
			do j=1,3,1
				write(999,'(F16.9)',ADVANCE='NO') aij(x,y,z,i,j,mat)
			end do
			write(999,*)
		end do
	end do
end do
end do

CLOSE(999)

end subroutine savetensort

subroutine loadtensort(aij,xmax,ymax,zmax,mat,matmax,fname)
integer :: xmax,ymax,zmax,i,j,k,mat,matmax,nn,x,y,z
real, INTENT (INOUT) :: aij(-xmax:(xmax+1),-ymax:(ymax+1),-zmax:(zmax+1),1:3,1:3,1:matmax)
real :: t(1:3,1:3)
character(255) :: fname

OPEN(UNIT=999,FILE=fname,STATUS='OLD',ACTION='READ',FORM='FORMATTED')

read(999,'(I9)') nn

do k=1,nn,1
		read(999,'(3I6)') x,y,z
		do i=1,3,1
				read(999,'(3F16.9)') t(i,1:3)
		end do
		if ((x<=(xmax+1)).and.(x>=-xmax).and.(y<=(ymax+1)).and.(y>=-ymax).and.(z<=(zmax+1)).and.(z>=-zmax)) then
			aij(x,y,z,1:3,1:3,mat)=t(1:3,1:3)
		end if
end do


CLOSE(999)

end subroutine loadtensort

subroutine savetensor(aij,xmax,ymax,zmax,mat,matmax,fname)
integer :: xmax,ymax,zmax,i,j,x,y,z,mat,matmax,ii
real, INTENT (IN) :: aij(-xmax:(xmax+1),-ymax:(ymax+1),-zmax:(zmax+1),1:3,1:3,1:matmax)
character(255) :: fname

inquire(iolength=i) x,y,z,aij(x,y,z,1:3,1:3,mat)


OPEN(UNIT=999,FILE=fname,STATUS='REPLACE',ACTION='WRITE',FORM='UNFORMATTED',ACCESS='DIRECT',RECL=i)

write(999,REC=1) (2*xmax+2)*(2*ymax+2)*(2*zmax+2),xmax,ymax,aij(0,0,0,1:3,1:3,mat)
ii=2
do x=-xmax,xmax+1,1
	do y=-ymax,ymax+1,1
	 do z=-zmax,zmax+1,1
				write(999,REC=ii) x,y,z,aij(x,y,z,1:3,1:3,mat)
				ii=ii+1
	end do
end do
end do

CLOSE(999)

end subroutine savetensor

subroutine loadtensor(aij,xmax,ymax,zmax,mat,matmax,fname)
integer :: xmax,ymax,zmax,i,j,x,y,z,mat,matmax,nn
real, INTENT (INOUT) :: aij(-xmax:(xmax+1),-ymax:(ymax+1),-zmax:(zmax+1),1:3,1:3,1:matmax)
real :: t(1:3,1:3)
character(255) :: fname

inquire(iolength=i) x,y,z,aij(x,y,z,1:3,1:3,mat)


OPEN(UNIT=999,FILE=fname,STATUS='OLD',ACTION='READ',FORM='UNFORMATTED',ACCESS='DIRECT',RECL=i)

read(999,REC=1) nn,x,y,aij(0,0,0,1:3,1:3,mat)

do i=2,nn+1,1
	read(999,REC=i) x,y,z,t(1:3,1:3)
	if ((x<=(xmax+1)).and.(x>=-xmax).and.(y<=(ymax+1)).and.(y>=-ymax).and.(z<=(zmax+1)).and.(z>=-zmax)) then
		aij(x,y,z,1:3,1:3,mat)=t(1:3,1:3)
	end if
end do

CLOSE(999)

end subroutine loadtensor

subroutine addanisotropy(aij,ms,xmax,ymax,zmax,cx,cy,cz,koeff,i,matmax)
    integer :: i,x,y,z,matmax,xmax,ymax,zmax,j,k
    real ::ms(1:matmax)
    real :: cx,cy,cz,koeff,d(1:3)
    real, INTENT (INOUT) :: aij(-xmax:(xmax+1),-ymax:(ymax+1),-zmax:(zmax+1),1:3,1:3,1:matmax)
    
    d(1)=cx
    d(2)=cy
    d(3)=cz
    koeff=koeff/(ms(i)*ms(i))
!    do x=-xmax,xmax+1
!    do y=-ymax,ymax+1
!    do z=-zmax,zmax+1
    x=0
    y=0
    z=0
	do j=1,3,1
        do k=1,3,1
	aij(x,y,z,j,k,i)=aij(x,y,z,j,k,i)+koeff*d(j)*d(k)
	end do
	end do
!    end do
!    end do
!    end do
    
end subroutine addanisotropy

subroutine addanisotropy_field(aij,ms,xmax,ymax,zmax,cx,cy,cz,koeff,i,matmax)
    integer :: i,x,y,z,matmax,xmax,ymax,zmax,j,k
    real ::ms(1:matmax)
    real :: cx,cy,cz,koeff,d(1:3)
    real, INTENT (INOUT) :: aij(-xmax:(xmax+1),-ymax:(ymax+1),-zmax:(zmax+1),1:3,1:3,1:matmax)
    
    d(1)=cx
    d(2)=cy
    d(3)=cz
    koeff=koeff/ms(i)
!    do x=-xmax,xmax+1
!    do y=-ymax,ymax+1
!    do z=-zmax,zmax+1
    x=0
    y=0
    z=0
	do j=1,3,1
        do k=1,3,1
	aij(x,y,z,j,k,i)=aij(x,y,z,j,k,i)+koeff*d(j)*d(k)
	end do
	end do
!    end do
!    end do
!    end do
    
end subroutine addanisotropy_field

subroutine tensornewall(A,Ms,aij,xmax,ymax,zmax,xstep,ystep,zstep,mat,matmax)
	integer :: xmax,ymax,zmax,matmax,mat
	real :: A(1:matmax),Ms(1:matmax),xstep,ystep,zstep
	real, INTENT (INOUT) :: aij(-xmax:(xmax+1),-ymax:(ymax+1),-zmax:(zmax+1),1:3,1:3,1:matmax)
	integer :: x,y,z,i,j,k,i2,j2,k2
	real :: t1,t2,t3,t4,r
	real :: Jx,Jy,Jz,v,x2,y2,z2

	Jx=2*A(mat)/(Ms(mat)*Ms(mat)*xstep*xstep)
	Jy=2*A(mat)/(Ms(mat)*Ms(mat)*ystep*ystep)
	Jz=2*A(mat)/(Ms(mat)*Ms(mat)*zstep*zstep)

	v=(xstep)*(ystep)*(zstep)
do x=-xmax,xmax+1,1
do y=-ymax,ymax+1,1
do z=-zmax,zmax+1,1
	x2=xstep*x
	y2=y*ystep
	z2=z*zstep

!	write(*,*) x,y,z
	call nxx(x2,y2,z2,xstep,ystep,zstep,aij(x,y,z,1,1,mat))
	call nxx(y2,-x2,z2,ystep,xstep,zstep,aij(x,y,z,2,2,mat))
!	call nxx(y2,x2,z2,ystep,xstep,zstep,aij(x,y,z,2,2,mat))
	call nxx(z2,x2,y2,zstep,xstep,ystep,aij(x,y,z,3,3,mat))

	call nxy(x2,y2,z2,xstep,ystep,zstep,aij(x,y,z,1,2,mat))
	call nxy(x2,z2,-y2,xstep,zstep,ystep,aij(x,y,z,1,3,mat))
!	call nxy(x2,z2,y2,xstep,zstep,ystep,aij(x,y,z,1,3,mat))
	call nxy(y2,z2,x2,ystep,zstep,xstep,aij(x,y,z,2,3,mat))

	aij(x,y,z,2,1,mat)=aij(x,y,z,1,2,mat)
	aij(x,y,z,3,1,mat)=aij(x,y,z,1,3,mat)
	aij(x,y,z,3,2,mat)=aij(x,y,z,2,3,mat)
!	aij(x,y,z,1:3,1:3,mat)=v*aij(x,y,z,1:3,1:3,mat)


	if ((abs(x).eq.1).and.(y.eq.0).and.(z.eq.0)) then
		aij(x,y,z,1,1,mat)=aij(x,y,z,1,1,mat)+Jx
		aij(x,y,z,2,2,mat)=aij(x,y,z,2,2,mat)+Jx
		aij(x,y,z,3,3,mat)=aij(x,y,z,3,3,mat)+Jx
	end if
	if ((x.eq.0).and.(abs(y).eq.1).and.(z.eq.0)) then
		aij(x,y,z,1,1,mat)=aij(x,y,z,1,1,mat)+Jy
		aij(x,y,z,2,2,mat)=aij(x,y,z,2,2,mat)+Jy
		aij(x,y,z,3,3,mat)=aij(x,y,z,3,3,mat)+Jy
	end if

	if ((x.eq.0).and.(y.eq.0).and.(abs(z).eq.1)) then
		aij(x,y,z,1,1,mat)=aij(x,y,z,1,1,mat)+Jz
		aij(x,y,z,2,2,mat)=aij(x,y,z,2,2,mat)+Jz
		aij(x,y,z,3,3,mat)=aij(x,y,z,3,3,mat)+Jz
	end if

end do
end do
end do

end subroutine tensornewall

subroutine f(x,y,z,xstep,ystep,zstep,res)
	real :: x,y,z
	real :: xstep,ystep,zstep
	real :: res,r1,r2,r3,r4

!	write(*,*) "f1 calling"
!	write(*,*) x,y,z,xstep,ystep,zstep
	call f1(x,y+ystep,z+zstep,xstep,ystep,zstep,r1)
	call f1(x,y,z+zstep,xstep,ystep,zstep,r2)
	call f1(x,y+ystep,z,xstep,ystep,zstep,r3)
	call f1(x,y,z,xstep,ystep,zstep,r4)
	res=r1-r2-r3+r4 
!	write(*,*) "f finished"
end subroutine f

subroutine f1(x,y,z,xstep,ystep,zstep,res)
	real :: x,y,z
	real :: xstep,ystep,zstep
	real :: res,r1,r2,r3,r4

!	write(*,*) "f2 calling"
!	write(*,*) x,y,z,xstep,ystep,zstep
	call f2(x,y-ystep,z-zstep,r1)
	call f2(x,y,z-zstep,r2)
	call f2(x,y-ystep,z,r3)
	call f2(x,y,z,r4)
	res=r1-r2-r3+r4 
!	write(*,*) "f1 finished"
end subroutine f1

subroutine f2(x,y,z,res)
	real :: x,y,z
	real :: res,r1,r2,r3,r4

!	write(*,*) "fs calling"
	call fs(x,y,z,r1)
	call fs(x,real(0),z,r2)
	call fs(x,y,real(0),r3)
	call fs(x,real(0),real(0),r4)
	res=r1-r2-r3+r4 
!	write(*,*) "f2 finished"
end subroutine f2

subroutine fs(x,y,z,res)
	real :: x,y,z
	real :: res,r1,r2,r3,r4
	
!	write(*,*) "ph calling"
!	write(*,*) x,y,z
! watch out for /0
	
	if ((abs(x)<1D-10).and.(abs(z)<1D-10)) then
	    r1=0
	else
	    call ph(y/sqrt(x*x+z*z),r1)
	end if
	if ((abs(x)<1D-200).and.(abs(y)<1D-200)) then
	    r2=0
	else
	    call ph(z/sqrt(x*x+y*y),r2)
	end if
	r3=sqrt(x*x+y*y+z*z)
	if (abs(x)<1D-10) then
	    r4=0
	else	
	    r4=atan(y*z/(x*r3))
!	call atg(r4,y*z,x*r3)
	end if

!	write(*,*) r1,r2,r3,r4

	res=(y/2)*(z*z-x*x)*r1+(z/2)*(y*y-x*x)*r2-x*y*z*r4+(r3/6)*(2*x*x-y*y-z*z)
!	write(*,*) "fs finished"

end subroutine fs

subroutine ph(x,res)
	real :: x,res
!	write(*,*) x,x+sqrt(1+x*x)
	res=log(x+sqrt(1+x*x))
end subroutine ph

subroutine nxx(x,y,z,xstep,ystep,zstep,res)
	real :: x,y,z,d
	real :: xstep,ystep,zstep
	real :: res,r1,r2,r3
	real, parameter :: pi=3.14159265

	d=xstep*ystep*zstep

!	write(*,*) x,y,z,xstep,ystep,zstep
!	write(*,*) "f calling"

	call f(x,y,z,xstep,ystep,zstep,r1)
	call f(x+xstep,y,z,xstep,ystep,zstep,r2)
	call f(x-xstep,y,z,xstep,ystep,zstep,r3)
!	res=res-(2*r1-r2-r3)/(4*pi*d)
	res=res-(2*r1-r2-r3)/(d)
!	if ((abs(x)<0.5).and. (abs(y)<0.5).and.(abs(x)<0.5)) then
!	    write(15,*) r1,r2,r3
!	end if
!	write(*,*) res

end subroutine nxx


subroutine g1(x,y,z,xstep,ystep,zstep,res)
	real :: x,y,z
	real :: xstep,ystep,zstep
	real :: res,r1,r2,r3,r4

	call g2(x+xstep,y,z+zstep,r1)
	call g2(x+xstep,y,z,r2)
	call g2(x,y,z+zstep,r3)
	call g2(x,y,z,r4)
	res=r1-r2-r3+r4 
end subroutine g1

subroutine g(x,y,z,xstep,ystep,zstep,res)
	real :: x,y,z
	real :: xstep,ystep,zstep
	real :: res,r1,r2,r3,r4

	call g1(x,y-ystep,z-zstep,xstep,ystep,zstep,r1)
	call g1(x,y,z-zstep,xstep,ystep,zstep,r2)
	call g1(x,y-ystep,z,xstep,ystep,zstep,r3)
	call g1(x,y,z,xstep,ystep,zstep,r4)
	res=r1-r2-r3+r4 
end subroutine g

subroutine g2(x,y,z,res)
	real :: x,y,z
	real :: res,r1,r2

	call gs(x,y,z,r1)
	call gs(x,y,real(0),r2)
	res=r1-r2
end subroutine g2

subroutine gs(x,y,z,res)
	real :: x,y,z
	real :: res,r1,r2,r22,r3,r4,r42,r43
	
	if ((abs(x)<1D-10).or.(abs(y)<1D-10)) then
	    r1=0
	else
	    call ph(z/sqrt(x*x+y*y),r1)
	end if
	if (abs(y)<1D-10) then
	    r2=0
	else
	    call ph(x/sqrt(z*z+y*y),r2)
	end if
	if (abs(x)<1D-10) then
	    r22=0
	else
	    call ph(y/sqrt(z*z+x*x),r22)
	end if
	r3=sqrt(x*x+y*y+z*z)
	if (abs(z)<1D-10) then
	    r4=0
	else
	    r4=atan(y*x/(z*r3))
!	    call atg(r4,y*x,z*r3)
	end if
	if (abs(y)<1D-10) then
	    r42=0
	else
	    r42=atan(z*x/(y*r3))
!	    call atg(r42,z*x,y*r3)
	end if	
	if (abs(x)<1D-10) then
	    r43=0
	else
	    r43=atan(z*y/(x*r3))
!	    call atg(r43,z*y,x*r3)
	end if	

!	call atg(r4,y*x,z*r3)
!	call atg(r42,z*x,y*r3)
!	call atg(r43,z*y,x*r3)

	res=x*y*z*r1+(y/6)*(3*z*z-y*y)*r2+(x/6)*(3*z*z-x*x)*r22-(z*z*z/6)*r4-(z*y*y/2)*r42-(z*x*x/2)*r43-(x*y*r3/3)

end subroutine gs

subroutine nxy(x,y,z,xstep,ystep,zstep,res)
	real :: x,y,z,d
	real :: xstep,ystep,zstep
	real :: res,r1,r2,r3,r4
	real, parameter :: pi=3.14159265

	d=xstep*ystep*zstep
	call g(x,y,z,xstep,ystep,zstep,r1)
	call g(x-xstep,y,z,xstep,ystep,zstep,r2)
	call g(x,y+ystep,z,xstep,ystep,zstep,r3)
	call g(x-xstep,y+ystep,z,xstep,ystep,zstep,r4)
	res=res-(r1-r2-r3+r4)/(d)
!	res=res-(r1-r2-r3+r4)/(d)
end subroutine nxy

subroutine calcmacro(aij_fft,ms,masque,xmax,ymax,zmax,matmax)
    integer :: xmax,ymax,zmax,matmax
    complex :: aij_fft(1:(2*xmax+2),1:(2*ymax+2),1:(2*zmax+2),1:3,1:3,1:matmax)
    integer :: masque(0:xmax,0:ymax,0:zmax)
    real :: ms(matmax),m(0:xmax,0:ymax,0:zmax,1:3)
    real :: h(0:xmax,0:ymax,0:zmax,1:3),mp(3),beta,aij(0:1,0:1,0:1,1:3,1:3,1:1)
    integer :: i,j,x,y,z,n
    real :: mx(3),mpp(3),mxx,mxy,mxz
    
    mp=0
    beta=0
    aij=0
    m=0

    do i=1,3
    do j=1,3
	mx=0
	mx(j)=1
	mpp=0
	n=0
	call initdir(m,ms,xmax,ymax,zmax,masque,mx(1),mx(2),mx(3),matmax)
	h=0
	call calcfieldsfft(aij_fft,m,ms,mp,beta,h,masque,xmax,ymax,zmax,matmax)
	do x=0,xmax
	do y=0,ymax
	do z=0,zmax
	    if(masque(x,y,z).ne.0) then
		mpp(1:3)=mpp(1:3)+h(x,y,z,1:3)
		n=n+1
	    end if
	end do
	end do
	end do
	mpp=mpp/(n*ms(1))
	aij(0,0,0,i,j,1)=mpp(i)
    end do
    end do
    call savetensort(aij,0,0,0,1,1,"macro.txt")
    call savetensor(aij,0,0,0,1,1,"macro.dat")
    
end subroutine calcmacro